Bug Hunting Session
Bug 43901 - RTL Toolbar icons order becomes opposite when in OLE object edit mode
Summary: RTL Toolbar icons order becomes opposite when in OLE object edit mode
Status: VERIFIED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: UI (show other bugs)
Version:
(earliest affected)
3.4.4 release
Hardware: Other All
: medium normal
Assignee: Not Assigned
URL:
Whiteboard: target:4.0.0 target:3.6.5
Keywords:
Depends on:
Blocks: RTL-CTL
  Show dependency treegraph
 
Reported: 2011-12-16 16:29 UTC by Lior Kaplan
Modified: 2012-12-04 18:24 UTC (History)
2 users (show)

See Also:
Crash report or crash signature:


Attachments
Normal RTL UI (81.33 KB, image/png)
2011-12-16 16:29 UTC, Lior Kaplan
Details
RTL UI when in OLE editing mode (68.09 KB, image/png)
2011-12-16 16:29 UTC, Lior Kaplan
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Lior Kaplan 2011-12-16 16:29:28 UTC
Created attachment 54520 [details]
Normal RTL UI

When using an RTL UI the toolbar icons start from the right (e.g. the standard toolbar). But when inserting an LibO OLE object and editing it, the button order changes to the one of the LTR UI, although the menu line is still in the correct order.

Notice the location of the help button on the standard toolbar in the screenshots attached (taken from writer). When in writer the button is on the left side (as the last button when started from the right, due to the RTL UI). But when in OLE (writer object inserted to draw), the help button is on the right side, as it is on LTR UI.
Comment 1 Lior Kaplan 2011-12-16 16:29:59 UTC
Created attachment 54521 [details]
RTL UI when in OLE editing mode
Comment 2 Rainer Bielefeld Retired 2011-12-17 00:02:00 UTC
[Reproducible] with "LibreOffice 3.4.5 RC1  - WIN7 Home Premium (64bit) Arabic UI [Build ID: OOO340m1 (Build:501)]" and with 
Parallel Dev-Installation of  "LibreOffice 3.5.0 Beta1 - WIN7 Home Premium (64bit) Hebrew UI [Build-ID: 7362ca8-b5a8e65-af86909-d471f98-61464c4] Windows_Release_Configuration  11-Dec-2011 06:51" 

All toolbars switch from RTL to LTR view when edit mode for OLE object starts

Steps to reproduce:
1. open attached Sample.odg with LibO RTL UI setting
   Observe icon sort order in toolbars
2. Double click Test OLE object in document
   Expected: Icon sort order in Toolbars remains RLT
   Actual: Icon sort order in Toolbars switches to LTR

Of course you can continue work, but hat is a very ugly effect; I would nominate this bug as a "Most Annoying" one.
Comment 3 Lior Kaplan 2011-12-17 07:12:46 UTC
Even weirder behavior in OLE edit mode, is that floating toolbar movement is opposite. If I try to drag a floating toolbar left, it moves right (!). When it's dock to the right border, and I want undock it, dragging it left doesn't help only dragging it right does (de facto dragging it outside of the LibO window). Seems that something is very wrong with calculating the location of the toolbar.
Comment 4 Rainer Bielefeld Retired 2011-12-18 21:40:12 UTC
DUP of "Bug 42577 - RTL UI [AR] toolbar view mirrored (docking and expand at the wrong side) when Insert Object Formula"?
Comment 5 Lior Kaplan 2011-12-19 00:34:32 UTC
Bug 42577 reports about the same problem in a different situation, but I wouldn't mark them as duplicate without know the problem comes from the same code.
Comment 6 Lior Kaplan 2012-06-12 06:26:02 UTC
Also happens in 3.5.4 (Debian, 64bit).
Comment 7 Not Assigned 2012-12-03 17:18:11 UTC
Abdulmajeed Al-Abaulrazzaq committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=aa61177f1d339422acb3322c8851962cd1ca7466

fdo#43901 & fdo#42577 RTL tollbars mirroring & fdo#56412



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 8 Lior Kaplan 2012-12-04 09:32:55 UTC
Verified fix on a private build. I can't believe it's only a one line change.
Comment 9 Not Assigned 2012-12-04 18:24:06 UTC
Abdulmajeed Al-Abaulrazzaq committed a patch related to this issue.
It has been pushed to "libreoffice-3-6":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=b8a3c7d71255adc58cb254fca180ca374ae4b516&g=libreoffice-3-6

Resolves: fdo#43901 and fdo#42577 RTL tollbars mirroring


It will be available in LibreOffice 3.6.5.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.